#!/bin/bash
# lookup:
# Does a dictionary lookup on each word in a data file.

file=words.data  # Data file to read words to test from.

echo

while [ "$word" != end ]  # Last word in data file.
do
  read word   # From data file, because of redirection at end of loop.
  look $word > /dev/null  # Don't want to display lines in dictionary file.
  lookup=$?   # Exit value of 'look'.

  if [ "$lookup" -eq 0 ]
  then
    echo "\"$word\" is valid."
  else
    echo "\"$word\" is invalid."
  fi  

done <$file  # Redirects stdin to $file, so "reads" come from there.

echo

exit 0
