#! /bin/bash
#
# Very simpleminded filename "rename" utility.
# Based on "lowercase.sh".


if [ $# -ne 2 ]
then
  echo "Usage: `basename $0` old-pattern new-pattern"
  # As in "rn gif jpg", which renames all gif files in working directory to jpg.
  exit 1
fi

number=0    # Keeps track of how many files actually renamed.


for filename in *$1*  #Traverse all matching files in directory.
do
   if [ -f $filename ]  # If finds match...
   then
     fname=`basename $filename`            # Strip off path.
     n=`echo $fname | sed -e "s/$1/$2/"`   # Substitute new for old in filename.
     mv $fname $n                          # Rename.
     let "number += 1"
   fi
done   

if [ $number -eq 1 ]   # For correct grammar.
then
 echo "$number file renamed."
else 
 echo "$number files renamed."
fi 

exit 0


# Exercise for reader:
# What type of files will this not work on?
# How to fix this?
